﻿var httpRequest = null;
var currentList = -1;
var listTypes = [{"name" : "New Releases", "url" : "http://feeds.rhapsody.com/new-releases.rss"},
                  {"name" : "Just Added", "url" : "http://feeds.rhapsody.com/just-added.rss"}, 
                  {"name" : "Staff Picks", "url" : "http://feeds.rhapsody.com/staff-picks.rss"},
                  {"name" : "Top Albums", "url" : "http://feeds.rhapsody.com/album-chart.rss"}];
                  
var currentAlbum = -1;
var timer = null;
var delay = 5000;
var fadeTime = 500;
var refreshPeriod = 1000 * 60 * 60 * 24;
    
function refreshList()
{
    listTypes[currentList].lastUpdate = new Date();
    httpRequest = new XMLHttpRequest();
    httpRequest.open("GET", listTypes[currentList].url, true);
    httpRequest.onreadystatechange = parseAlbumList;
    httpRequest.send(null);
}

function parseAlbumList() 
{
    if (httpRequest.readyState == 4) {
        if (httpRequest.status == 200) {
            tempAlbums = new Array();
            
            var doc = new DOMDocument();
            doc.loadXML(httpRequest.responseText);
            
            var root = doc.getElementsByTagName('rss')[0];
            
            var channels = root.getElementsByTagName('channel');
            var items = channels[0].getElementsByTagName('item');
            
            for (var i = 0; i < items.length; i++)
            {
                try 
                {
                    var albumName = items[i].getElementsByTagName("rhap:album")[0].firstChild.nodeValue;
                    var artistName = items[i].getElementsByTagName("rhap:artist")[0].firstChild.nodeValue;
                    var imgUrl = items[i].getElementsByTagName("rhap:album-art")[0].firstChild.nodeValue;
                    var albumUrl = "http://www.rhapsody.com/goto?rcid=" + items[i].getElementsByTagName("rhap:rcid")[0].firstChild.nodeValue;
                    
                    tempAlbums.push ({ 
                        "artistName" : artistName,
                        "albumName" : albumName,
                        "imgUrl" : imgUrl,
                        "albumUrl" : albumUrl
                    });
                }
                catch (e)
                {
                }
            }    
            listTypes[currentList].albums = tempAlbums;
            currentAlbum = -1;
            timer = null;
            displayAlbum();
                
        }
    }
}

function loadImage(album) 
{
    var http = new XMLHttpRequest();
    var locArtistLabel = artistLabel;
    var locAlbumLabel = albumLabel;
    var locArtistName = album.artistName;
    var locAlbumName = album.albumName;
    http.onreadystatechange = onData;
    http.open("GET", album.imgUrl, "true");
    http.send();

    function onData()
    {
        if (http.readyState == 4)
        {
            var source = http.responseStream;
            albumImage.src = source;            
            locArtistLabel.innerText = locArtistName;
            locAlbumLabel.innerText = locAlbumName;
        } 
    }
}

function view_onOpen()
{
    nextList();
}

function displayAlbum()
{
    try 
    {
        currentAlbum++;
        
        var albums = listTypes[currentList].albums;
                
        if (albums == null) 
            return;
            
        if (currentAlbum >= albums.length) {
            nextList();    
            return;
        }
        
        /* if (listTypeLabel.innerText != listTypes[currentList].name) {
            view.beginAnimation(function() { setElementOpacity(listTypeLabel); }, 
                                255, 
                                0, 
                                fadeTime); 
        }
        
        if (albumImage.scr != "") {
            view.beginAnimation(function() { setElementOpacity(albumImage); }, 
                                255, 
                                0, 
                                fadeTime); 
            view.beginAnimation(function() { setElementOpacity(albumLabel); }, 
                                255, 
                                0, 
                                fadeTime); 
            view.beginAnimation(function() { setElementOpacity(artistLabel); }, 
                                255, 
                                0, 
                                fadeTime); 
        }
        
        setTimeout(displayAlbumContinue, fadeTime);     
        
        */
        
        displayAlbumContinue();
    }
    catch (e)
    {
        timer = setTimeout(displayAlbum, delay);     
    }
       
}

function displayAlbumContinue() {
    
    var albums = listTypes[currentList].albums
    var newTypeLabel = false;
    
    if (listTypeLabel.innerText != listTypes[currentList].name) {
        listTypeLabel.innerText = listTypes[currentList].name;
        newTypeLabel = true;
    }
    
    loadImage(albums[currentAlbum]);
    albumImage.onclick = function() {
        var winShell = new ActiveXObject("Shell.Application");
        winShell.ShellExecute(albums[currentAlbum].albumUrl); 
    };
    /* if (newTypeLabel)
        view.beginAnimation(function() { setElementOpacity(listTypeLabel); }, 
                            0, 
                            255, 
                            fadeTime); 
    view.beginAnimation(function() { setElementOpacity(albumImage); }, 
                        0, 
                        255, 
                        fadeTime); 
    view.beginAnimation(function() { setElementOpacity(albumLabel); }, 
                        0, 
                        255, 
                        fadeTime); 
    view.beginAnimation(function() { setElementOpacity(artistLabel); }, 
                        0, 
                        255, 
                        fadeTime); */
    timer = setTimeout("displayAlbum()", delay);
}

function nextList() {
    today = new Date();
    currentAlbum = -1;
    
    currentList++;
    
    if (currentList >= listTypes.length) {
        currentList = 0;
    }

    if (listTypes[currentList].lastUpdate == null) {
        refreshList();
    }
    else if (Math.ceil((today.getTime() - listTypes[currentList].lastUpdate.getTime()) / refreshPeriod) > 0) {
        refreshList();
    }
    else {
        displayAlbum();
    }
}

function setElementOpacity(element) {
    element.opacity = event.value;
}
